﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace example
{
    public partial class Form1 : Form
    {
        [DllImport("pdftops.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MBegin();

        [DllImport("pdftops.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetParam(int id, int itype, string sparam, int iparam, int iparam2);

        [DllImport("pdftops.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MConvert(int id, string inpdf, string password, string outps);

        [DllImport("pdftops.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEnd(int id);


        const int M_PS_LEVEL	= 100;
        const int M_PAPER_SIZE	= 101;
        const int M_EXPAND		= 102;
        const int M_SHRINK		= 103;
        const int M_CENTER		= 104;
        const int M_DUPLEX		= 105;


        const int M_LEVEL1	=1; //Level 1 PostScript
        const int M_LEVEL1S	=2; //Level 1 Separable PostScript
        const int M_LEVEL2	=3; //Level 2 PostScript
        const int M_LEVEL2S	=4; //Level 2 Separable PostScript
        const int M_LEVEL3	=5; //Level 3 PostScript
        const int M_LEVEL3S = 6; //Level 3 Separable PostScript
        const int M_LEVEL_EPS=7;//Encapsulated PostScript (EPS)
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outFile = appPath + "\\output.ps";   
            
            int id = MBegin();    
            if(id>0)
            {
                MSetParam(id, M_PS_LEVEL, "", M_LEVEL2, 0);
                MSetParam(id, M_PAPER_SIZE, "A3", 0, 0);
                MSetParam(id, M_CENTER, "", 1, 0);
                MSetParam(id, M_SHRINK, "", 1, 0);
                MSetParam(id, M_EXPAND, "", 1, 0);

                MConvert(id, inFile, "", outFile);
                MEnd(id);
	        }	
	        MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outFile = appPath + "\\output2.ps";              
            
            int id = MBegin();
            if (id > 0)
            {
                MSetParam(id, M_PS_LEVEL, "", M_LEVEL3, 0);
                MSetParam(id, M_PAPER_SIZE, "", 600, 800);
                MSetParam(id, M_CENTER, "", 1, 0);
                MSetParam(id, M_SHRINK, "", 1, 0);
                MSetParam(id, M_DUPLEX, "", 1, 0);

                MConvert(id, inFile, "", outFile);
                MEnd(id);
            }

            MessageBox.Show("Convert finished!");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile = appPath + "\\test.pdf";
            string outFile = appPath + "\\outeps\\";

            int id = MBegin();
            if (id > 0)
            {
                MSetParam(id, M_PS_LEVEL, "", M_LEVEL_EPS, 0);
                MSetParam(id, M_PAPER_SIZE, "A4", 0, 0);
                MSetParam(id, M_CENTER, "", 1, 0);
                MSetParam(id, M_SHRINK, "", 1, 0);
                MSetParam(id, M_DUPLEX, "", 1, 0);

                MConvert(id, inFile, "", outFile);
                MEnd(id);
            }

            MessageBox.Show("Convert finished!");
        }
    }
}
