//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadPdfToPsDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pdftops.dll");	

	m_hinstLib = LoadLibrary(path);
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreePdfToPsDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreePdfToPsDll();
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreePdfToPsDll();
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreePdfToPsDll();
		return FALSE;
	}
    
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreePdfToPsDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadPdfToPsDll() == FALSE ){
		ShowMessage("Load pdftops.dll failed!");
		return;
	}
 	char infile[256],outfile[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outfile,"output.ps");
    
	long id = pMBegin();
	if(id>0){
		pMSetParam(id,M_PS_LEVEL,"",M_LEVEL2,0);
		pMSetParam(id,M_PAPER_SIZE,"A0",0,0);	
		pMSetParam(id,M_CENTER,"",1,0);	
		pMSetParam(id,M_SHRINK,"",1,0);	
		pMSetParam(id,M_EXPAND,"",1,0);			

		pMConvert(id,infile,"",outfile);
		pMEnd(id);
	}	

	FreePdfToPsDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadPdfToPsDll() == FALSE ){
		ShowMessage("Load pdftops.dll failed!");
		return;
	}
	char infile[256],outfile[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outfile,"output2.ps");
    
	long id = pMBegin();
	if(id>0){
		pMSetParam(id,M_PS_LEVEL,"",M_LEVEL3,0);
		pMSetParam(id,M_PAPER_SIZE,"",600,800);	
		pMSetParam(id,M_CENTER,"",1,0);	
		pMSetParam(id,M_SHRINK,"",1,0);	
		pMSetParam(id,M_DUPLEX,"",1,0);	

		pMConvert(id,infile,"",outfile);
		pMEnd(id);
	}

	FreePdfToPsDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if( LoadPdfToPsDll() == FALSE ){
		ShowMessage("Load pdftops.dll failed!");
		return;
	}
	char infile[256],outfile[256];
	GetModulePath(infile,"test.pdf");
	GetModulePath(outfile,"outeps\\");
    
	long id = pMBegin();
	if(id>0){
		pMSetParam(id,M_PS_LEVEL,"",M_LEVEL_EPS,0);
		pMSetParam(id,M_PAPER_SIZE,"A4",0,0);	
		pMSetParam(id,M_CENTER,"",1,0);	
		pMSetParam(id,M_SHRINK,"",1,0);	
		pMSetParam(id,M_DUPLEX,"",1,0);	

		pMConvert(id,infile,"",outfile);
		pMEnd(id);
	}

	FreePdfToPsDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------

